##############################################################################
##
## ***************************************************************************
## **                                                                       **
## ** Copyright (c) 1995-2010 Xilinx, Inc.  All rights reserved.            **
## **                                                                       **
## ** You may copy and modify these files for your own internal use solely  **
## ** with Xilinx programmable logic devices and Xilinx EDK system or       **
## ** create IP modules solely for Xilinx programmable logic devices and    **
## ** Xilinx EDK system. No rights are granted to distribute any files      **
## ** unless they are distributed in Xilinx programmable logic devices.     **
## **                                                                       **
## ***************************************************************************
##
##############################################################################

proc generate {drv_handle} {
    puts "Generating Macros for bce_fp11_1x8_0_axiw driver access ... "

    # initialize
    lappend config_table
    lappend addr_config_table
    lappend xparam_config_table

    # hardware version
    lappend config_table "C_XC_VERSION"
    # Low-level function names
    lappend config_table "C_XC_CREATE" "C_XC_RELEASE" "C_XC_OPEN" "C_XC_CLOSE" "C_XC_READ" "C_XC_WRITE" "C_XC_GET_SHMEM"
    # Optional parameters
    # (empty)

    # Memory map information
    sg_lappend config_table addr_config_table "C_MEMMAP_Z8"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z8_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z8_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z8_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z8_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z8_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_Z8_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_B8"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B8_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B8_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B8_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B8_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B8_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_B8_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_A8"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A8_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A8_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A8_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A8_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A8_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_A8_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_Z7"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z7_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z7_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z7_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z7_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z7_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_Z7_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_B7"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B7_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B7_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B7_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B7_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B7_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_B7_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_A7"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A7_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A7_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A7_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A7_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A7_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_A7_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_Z6"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z6_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z6_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z6_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z6_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z6_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_Z6_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_B6"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B6_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B6_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B6_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B6_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B6_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_B6_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_A6"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A6_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A6_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A6_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A6_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A6_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_A6_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_Z5"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z5_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z5_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z5_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z5_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z5_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_Z5_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_B5"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B5_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B5_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B5_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B5_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B5_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_B5_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_A5"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A5_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A5_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A5_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A5_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A5_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_A5_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_Z4"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z4_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z4_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z4_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z4_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z4_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_Z4_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_B4"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B4_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B4_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B4_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B4_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B4_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_B4_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_A4"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A4_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A4_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A4_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A4_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A4_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_A4_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_Z3"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z3_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z3_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z3_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z3_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z3_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_Z3_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_B3"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B3_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B3_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B3_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B3_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B3_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_B3_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_A3"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A3_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A3_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A3_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A3_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A3_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_A3_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_Z2"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z2_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z2_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z2_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z2_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z2_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_Z2_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_B2"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B2_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B2_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B2_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B2_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B2_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_B2_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_A2"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A2_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A2_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A2_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A2_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A2_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_A2_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_Z1"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z1_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_Z1_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z1_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z1_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_Z1_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_Z1_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_B1"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B1_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_B1_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B1_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B1_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_B1_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_B1_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_A1"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A1_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_A1_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A1_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A1_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_A1_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_A1_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_PB2MB"
    # sg_lappend config_table addr_config_table "C_MEMMAP_PB2MB_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_PB2MB_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PB2MB_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PB2MB_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_PB2MB_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_PB2MB_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_P1"
    # sg_lappend config_table addr_config_table "C_MEMMAP_P1_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_P1_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_P1_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_P1_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_P1_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_P1_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_P0"
    # sg_lappend config_table addr_config_table "C_MEMMAP_P0_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_P0_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_P0_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_P0_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_P0_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_P0_ATTR"
    sg_lappend config_table addr_config_table "C_MEMMAP_MB2PB"
    # sg_lappend config_table addr_config_table "C_MEMMAP_MB2PB_GRANT"
    # sg_lappend config_table addr_config_table "C_MEMMAP_MB2PB_REQ"
    sg_lappend config_table xparam_config_table "C_MEMMAP_MB2PB_N_BITS"
    sg_lappend config_table xparam_config_table "C_MEMMAP_MB2PB_BIN_PT"
    sg_lappend config_table xparam_config_table "C_MEMMAP_MB2PB_DEPTH"
    # sg_lappend config_table xparam_config_table "C_MEMMAP_MB2PB_ATTR"

    # XPS parameters
    sg_lappend config_table xparam_config_table "DEVICE_ID" "C_BASEADDR"

    # generate xparameters.h
    eval xdefine_include_file $drv_handle "xparameters.h" "BCE_FP11_1X8_0_AXIW" "NUM_INSTANCES" ${xparam_config_table}
    eval sg_xdefine_include_file $drv_handle "xparameters.h" "BCE_FP11_1X8_0_AXIW" ${addr_config_table}
    # generate bce_fp11_1x8_0_axiw_g.c
    eval xdefine_config_file $drv_handle "bce_fp11_1x8_0_axiw_g.c" "BCE_FP11_1X8_0_AXIW" ${config_table}
}

proc sg_xdefine_include_file {drv_handle file_name drv_string args} {
    # Open include file
    set file_handle [xopen_include_file $file_name]

    # Get all peripherals connected to this driver
    set periphs [xget_periphs $drv_handle] 

    # Print all parameters for all peripherals
    set device_id 0
    foreach periph ${periphs} {
        # base_addr of the peripheral
        set base_addr [xget_param_value ${periph} "C_BASEADDR"]

        puts ${file_handle} ""
        puts ${file_handle} "/* Definitions (address parameters) for peripheral [string toupper [xget_hw_name $periph]] */"
        foreach arg ${args} {
            set value [xget_param_value ${periph} ${arg}]
            if {[llength ${value}] == 0} {
                set value 0
            }
            set value [expr ${base_addr} + ${value}]
            set value_str [xformat_address_string ${value}]
            puts ${file_handle} "#define [xget_name ${periph} ${arg}] ${value_str}"
        }

        puts $file_handle "/* software driver settings for peripheral [string toupper [xget_hw_name $periph]] */"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_VERSION   1"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_CREATE    xc_bce_fp11_1x8_0_axiw_create"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_RELEASE   xc_bce_fp11_1x8_0_axiw_release"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_OPEN      xc_bce_fp11_1x8_0_axiw_open"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_CLOSE     xc_bce_fp11_1x8_0_axiw_close"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_READ      xc_bce_fp11_1x8_0_axiw_read"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_WRITE     xc_bce_fp11_1x8_0_axiw_write"
        puts $file_handle "#define XPAR_[string toupper [xget_hw_name ${periph}]]_XC_GET_SHMEM xc_bce_fp11_1x8_0_axiw_getshmem"

        puts $file_handle ""
    }		
    puts $file_handle "\n/******************************************************************/\n"
    close $file_handle
}

proc sg_lappend {required_config_table {extra_config_table ""} args} {
    upvar ${required_config_table} config_table_1
    if {[string length ${extra_config_table}] != 0} {
        upvar ${extra_config_table} config_table_2
    }

    foreach value ${args} {
        eval [list lappend config_table_1 ${value}]
        if {[string length ${extra_config_table}] != 0} {
            lappend config_table_2 ${value}
        }
    }
}
